from imutils import video
VideoStream = video.VideoStream
FPS = video.FPS
import numpy as np
import argparse
import imutils
import time
import cv2
import tensorflow  as tf
import random, os, time
import matplotlib.pyplot as plt
import matplotlib.image as mpimg
from tensorflow.keras.preprocessing import image
#from traffic2 import imgSize

imgSize = 32

class_names = ['Turn left ahead','Turn right ahead']


# Load model
new_model = tf.keras.models.load_model('my_model5.0.h5')

labelNames = open("signnames.csv").read().strip().split("\n")[1:]
labelNames = [l.split(",")[1] for l in labelNames]


# initialize the video stream, allow the cammera sensor to warmup,
# and initialize the FPS counter
print("[INFO] starting video stream...")
vs = VideoStream(src=0).start()
time.sleep(2.0)
fps = FPS().start()

# loop over the frames from the video stream
while True:
    # grab the frame from the threaded video stream and resize it
    # to have a maximum width of 400 pixels
    frame1 = vs.read()
    #frame = imutils.resize(frame, width=400)
    frame = cv2.resize(frame1, (imgSize, imgSize))

    test_image = image.img_to_array(frame)
    test_image = np.expand_dims(test_image, axis = 0)
    #result = new_model.predict(test_image)
    #result = result[0]
    #maxnum = max(result[0])
    #print(maxnum)
    #print(result)
    #result = np.where(result == maxnum)
    
    preds = new_model.predict(test_image)
    #print(preds)
    lst = (preds.tolist())[0]
    lst1 = []
    for l in lst:
        if l > 0.9:
            position = lst.index(l)
            if class_names[position] in class_names:
                lst1.append(class_names[position])
            
    print(lst1)
    
    #j = preds.argmax(axis=1)[0]
    #print(j)
    
    #result = result[0].index(max(result[0]))
    
    #result = class_names[int(result[0][0])]
    #print(result)

    # show the output frame
    cv2.imshow("Frame", frame1)
    key = cv2.waitKey(1) & 0xFF

    # if the `q` key was pressed, break from the loop
    if key == ord("q"):
        break

    # update the FPS counter
    fps.update()

# stop the timer and display FPS information
fps.stop()
print("[INFO] elapsed time: {:.2f}".format(fps.elapsed()))
print("[INFO] approx. FPS: {:.2f}".format(fps.fps()))

# do a bit of cleanup
cv2.destroyAllWindows()
vs.stop()
p()
